var _ = function(){
	var action = new PlugIn.Action(function(selection, sender){
		// action code
		// selection options: project, tasks, resources
		
		// CREATE INSTANCE OF FILEPICKER
		var picker = new FilePicker()
		picker.folders = false
		picker.multiple = false
		TSVtype = new FileType("public.tab-separated-values-text")
		CSVtype = new FileType("public.comma-separated-values-text")
		picker.types = [TSVtype,CSVtype]
		// DECLARE THE PROMISE VARIABLE
		var pickerPromise
		// CHECK PLATFORM
		if(app.platformName === "iOS"){
			msg = "Tap ”Continue” and choose the comma- or tab-delimited text file to import from the forthcoming file picker:"
			var alert = new Alert("Select File", msg)
			alert.addOption("Continue")
			alert.show(function(result){
				pickerPromise = picker.show()
				processPickerPromise(pickerPromise)
			})
		} else if (app.platformName === "macOS"){
			picker.message = "Choose the comma- or tab-delimited text file to import:"
			pickerPromise = picker.show()
			processPickerPromise(pickerPromise)
		}		
	});

	action.validate = function(selection, sender){
		// validation code
		// selection options: project, tasks, resources
		return true
	};
	
	return action;
}();
_;

function processPickerPromise(pickerPromise){
	// READ AND PROCESS CONTENTS OF THE CHOSEN TEXT FILE
	pickerPromise.then(function(urls){
		url = urls[0]
		var typeIndicator = (url.string.endsWith(".tsv")) ? 0:1
		url.fetch(function(data){
			data = data.toString().split(/\r?\n/)
			var items = new Array()
			for(var i = 0; i < data.length; i++){
				if(typeIndicator === 0){
					items.push(data[i].split(/\t/))
				} else {
					items.push(data[i].split(","))
				}
			}
			// GET THE CURRENT RESOURCE EMAIL ADDRESSES
			var resourceEmails = new Array()
			actual.rootResource.descendents().forEach((rsc)=>{
				if (rsc.type === ResourceType.staff && rsc.email){
					resourceEmails.push(rsc.email)
				}
			})
			// CREATE NEW RESOURCE FOR EACH UNIQUE ITEM
			items.forEach((item)=>{
				// TRIM ENCASING QUOTES IF SOURCE IS CSV
				var personName = (typeIndicator === 0) ? item[0]:item[0].replace(/^\"+|\"+$/gm,'')
				var personEmail = (typeIndicator === 0) ? item[1]:item[1].replace(/^\"+|\"+$/gm,'')
				// ADD PERSONS WITH UNIQUE EMAIL AS RESOURCES
				if (!resourceEmails.includes(personEmail)){
					newResource = actual.rootResource.addMember()
					newResource.type = ResourceType.staff
					newResource.name = personName
					newResource.email = personEmail
					resourceEmails.push(personEmail)
				}
			})
		})
	})
}